(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['module', 'exports'], factory);
  } else if (typeof exports !== "undefined") {
    factory(module, exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod, mod.exports);
    global.optionalChaining = mod.exports;
  }
})(this, function (module, exports) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = optionalChaining;
  function optionalChaining(object, path) {
    var separator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '.';

    if (arguments.length < 2) {
      throw new Error('Missing parameter.');
    }

    if (!Array.prototype.reduce) {
      throw new Error('Array.prototype.reduce is not supported in your environment, see https://github.com/es-shims/es5-shim');
    }

    try {
      return path.replace('[', separator).replace(']', '').split(separator).reduce(function (obj, property) {
        return obj[property];
      }, object);
    } catch (err) {
      return undefined;
    }
  }
  module.exports = exports['default'];
});